<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of actions 
 * Es para informe de facturación modulo cartera
 *
 * @author Manuel enrique Paredes Lopez
 * @email mparedes@sofhouse.net
 * @fecha 081119
 */
class inf_factActions extends sfActions{
    //put your code here
    
     /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request){
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.id_factura';
        }
        
        try{
            
                        //fecha obligatoria
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            
            
            //tipo
            $whereTipo = " ";
            if (isset($request['tipo']) ) {
                $whereTipo = " and tab0.tipo in (" . $request['tipo'] . ")";
            }
            
            
            //Estado abaco
            $whereAnulado = " ";
            if (isset($request['anulado_abaco'])) {
                $whereAnulado = " and tab0.anulado_abaco in (" . $request['anulado_abaco'] . ")";
            }
            
            //Estado abaco
            $whereEstadoAbaco = " ";
            if (isset($request['estado_abaco'])) {
                $whereEstadoAbaco = " and tab0.estado_abaco in (" . $request['estado_abaco'] . ")";
            }
            
             //INVOICE
            $whereInvoice = ' ';
            if (isset($request['idinvoice'])) {
                $whereInvoice = " AND tab0.idinvoice = " . $request['idinvoice'];
            } 
            
            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);
            
            
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

            SELECT 
        tab0.id_factura,
       tab0.usuario,
       tab0.fecha_log,
       tab0.idinvoice,
       tab0.message,
       tab0.successful_txt,
       tab0.idrequest,
       tab0.estado_abaco,
       tab0.estado_abaco_letras,
       tab0.fecha_abaco,
       tab0.estado_correo,
       tab0.fecha_correo,
       tab0.id_debito,
       tab0.anulado_abaco,
       tab0.anulado_abaco_letras,
       tab0.fecha_anulado,
       tab0.message_anulado,
       tab0.id,
       tab0.fecha,
       tab0.secuencia,
       tab0.num_doc,
       tab0.abreviatura_tipo_doc,   
       tab0.observaciones,             
       tab0.tercero,
       tab0.valor_total,
       case when tab0.tipo = 1 then 'Nota Factura' else 'Nota Debito' end as tipo_letras,
       tab0.tipo
       FROM INF_FACT_V tab0
        where   
tab0.fecha_log between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD')              
$whereTipo
$whereAnulado
$whereEstadoAbaco      
    $whereInvoice
    
   
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            
            
            
            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

SELECT 
       tab0.id_factura,
       tab0.usuario,
       tab0.fecha_log,
       tab0.idinvoice,
       tab0.message,
       tab0.successful_txt,
       tab0.idrequest,
       tab0.estado_abaco,
       tab0.estado_abaco_letras,
       tab0.fecha_abaco,
       tab0.estado_correo,
       tab0.fecha_correo,
       tab0.id_debito,
       tab0.anulado_abaco,
       tab0.anulado_abaco_letras,
       tab0.fecha_anulado,
       tab0.message_anulado,
       tab0.id,
       tab0.fecha,
       tab0.secuencia,
       tab0.num_doc,
       tab0.abreviatura_tipo_doc,   
       tab0.observaciones,           
       tab0.tercero,
       tab0.valor_total,
       case when tab0.tipo = 1 then 'Nota Factura' else 'Nota Debito' end as tipo_letras,
       tab0.tipo
       FROM INF_FACT_V tab0
        where   
tab0.fecha_log between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD') 
$whereTipo
$whereAnulado
$whereEstadoAbaco    
    $whereInvoice
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            
            
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_fact] Consulta exitosa.");
        } catch (Exception $ex) {
            
            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($ex->getMessage());

        }
        
        
        
        
    }
    
    
    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request){
        
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        
                /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.id_factura';
        }
        
        try{
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            
            //tipo
            $whereTipo = " ";
            if (isset($request['tipo']) ) {
                $whereTipo = " and tab0.tipo in (" . $request['tipo'] . ")";
            }
            
             //Estado abaco
            $whereAnulado = " ";
            if (isset($request['anulado_abaco'])) {
                $whereAnulado = " and tab0.anulado_abaco in (" . $request['anulado_abaco'] . ")";
            }
            
            //Estado abaco
            $whereEstadoAbaco = " ";
            if (isset($request['estado_abaco'])) {
                $whereEstadoAbaco = " and tab0.estado_abaco in (" . $request['estado_abaco'] . ")";
            }
            
            
             //INVOICE
            $whereInvoice = ' ';
            if (isset($request['idinvoice'])) {
                $whereInvoice = " AND tab0.idinvoice = " . $request['idinvoice'];
            } 
            
            
            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT
'Total: ' || count(*) as tipo_letras,
SUM(valor_total) as valor_total

FROM (  

SELECT 
                    
         tab0.id_factura,
       tab0.usuario,
       tab0.fecha_log,
       tab0.idinvoice,
       tab0.message,
       tab0.successful_txt,
       tab0.idrequest,
       tab0.estado_abaco,
       tab0.estado_abaco_letras,
       tab0.fecha_abaco,
       tab0.estado_correo,
       tab0.fecha_correo,
       tab0.id_debito,
       tab0.anulado_abaco,
       tab0.anulado_abaco_letras,
       tab0.fecha_anulado,
       tab0.message_anulado,
       tab0.id,
       tab0.fecha,
       tab0.secuencia,
       tab0.tercero,
       tab0.valor_total,
       case when tab0.tipo = 1 then 'FACTURA' else 'DEBITO' end as tipo_letras,
       tab0.tipo
FROM INF_FACT_V tab0
where   
tab0.fecha_log between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD') 
$whereTipo
$whereAnulado
$whereEstadoAbaco 
                    $whereInvoice
$sortBy                    
                    
)
EOD;
            
            
            
            
            
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
            
        } catch (Exception $ex) {
            
            
             $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());

        }
        
        
    }   
}
